set echo on feedback on timing on serveroutput on size 1000000
spool samp1

create or replace procedure samp1(in_parm1 in varchar2,
				  in_debug_mode in boolean default FALSE,
				  in_trace_mode in boolean default FALSE,
				  in_profile_mode in boolean default FALSE)
as
	--
	cursor get_rows(in_arg1 in varchar2)
	is
	select	something
	from	app_table;
	where	somewhere = in_arg1;
	--
	v_save_module		varchar2(100);
	v_save_action		varchar2(100);
	v_errctx		varchar2(1000);
	v_errmsg		varchar2(2000);
	--
begin
	--
	dbms_application_info.read_module(v_save_module, v_save_action);
	dbms_application_info.set_module('SAMP1','Starting...');
	--
	-- Enable SQL tracing if requested...
	--
	if in_trace_mode = TRUE then
		--
		v_errctx := 'enabling SQL trace level 12';
		dbms_output.put_line(substr(v_errctx,1,255));
		dbms_application_info.set_action(v_errctx);
		execute immediate 'alter session set tracefile_identifier = samp1';
		execute immediate 'alter session set max_dump_file_size = unlimited';
		execute immediate 'alter session set events ''10046 trace name context forever, level 12''';
		--
	end if;
	--
	-- Enable PL/SQL profiling if requested...
	--
	if in_profile_mode = TRUE then
		--
		v_errctx := 'dbms_profiler.start_profiler';
		dbms_profiler.start_profiler('SAMP1');
		--
	end if;
	--
	v_errctx := 'open/fetch get_rows';
	for x in get_rows(in_parm1) loop
		--
		v_errctx := x.something;
		if in_debug_mode = TRUE then
			--
			dbms_output.put_line(v_errctx);
			--
		else
			--
			dbms_application_info.set_action(v_errctx);
			execute immediate v_errctx;
			--
		end if;
		--
		v_errctx := 'fetch/close get_rows';
		--
	end loop;
	--
	commit;
	--
	dbms_application_info.set_module(v_save_module, v_save_action);
	--
exception
	--
	when others then
		v_errmsg := sqlerrm;
		dbms_application_info.set_module(v_save_module, v_save_action);
		raise_application_error(-20000, v_errctx || ': ' || v_errmsg);
	--
end samp1; /* end of procedure specification for SAMP1 */
/
show errors

spool off
set echo off feedback 6 timing off serveroutput off
